diff --git a/src/gui/kernel/qguiaction.h b/src/gui/kernel/qguiaction.h
new file mode 100644
index 0000000000..7672b312da
--- /dev/null
+++ b/src/gui/kernel/qguiaction.h
@@ -0,0 +1,199 @@
+/****************************************************************************
+**
+** Copyright (C) 2016 The Qt Company Ltd.
+** Contact: https://www.qt.io/licensing/
+**
+** This file is part of the QtWidgets module of the Qt Toolkit.
+**
+** $QT_BEGIN_LICENSE:LGPL$
+** Commercial License Usage
+** Licensees holding valid commercial Qt licenses may use this file in
+** accordance with the commercial license agreement provided with the
+** Software or, alternatively, in accordance with the terms contained in
+** a written agreement between you and The Qt Company. For licensing terms
+** and conditions see https://www.qt.io/terms-conditions. For further
+** information use the contact form at https://www.qt.io/contact-us.
+**
+** GNU Lesser General Public License Usage
+** Alternatively, this file may be used under the terms of the GNU Lesser
+** General Public License version 3 as published by the Free Software
+** Foundation and appearing in the file LICENSE.LGPL3 included in the
+** packaging of this file. Please review the following information to
+** ensure the GNU Lesser General Public License version 3 requirements
+** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
+**
+** GNU General Public License Usage
+** Alternatively, this file may be used under the terms of the GNU
+** General Public License version 2.0 or (at your option) the GNU General
+** Public license version 3 or any later version approved by the KDE Free
+** Qt Foundation. The licenses are as published by the Free Software
+** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
+** included in the packaging of this file. Please review the following
+** information to ensure the GNU General Public License requirements will
+** be met: https://www.gnu.org/licenses/gpl-2.0.html and
+** https://www.gnu.org/licenses/gpl-3.0.html.
+**
+** $QT_END_LICENSE$
+**
+****************************************************************************/
+
+#ifndef QGUIACTION_H
+#define QGUIACTION_H
+
+#include <QtGui/qtguiglobal.h>
+#include <QtGui/qkeysequence.h>
+#include <QtGui/qicon.h>
+#include <QtCore/qstring.h>
+#include <QtCore/qvariant.h>
+
+QT_BEGIN_NAMESPACE
+
+
+#ifndef QT_NO_ACTION
+
+class QActionEvent;
+class QGuiActionGroup;
+class QGuiActionPrivate;
+
+class Q_GUI_EXPORT QGuiAction : public QObject
+{
+    Q_OBJECT
+    Q_DECLARE_PRIVATE(QGuiAction)
+
+    Q_PROPERTY(bool checkable READ isCheckable WRITE setCheckable NOTIFY changed)
+    Q_PROPERTY(bool checked READ isChecked WRITE setChecked DESIGNABLE isCheckable NOTIFY toggled)
+    Q_PROPERTY(bool enabled READ isEnabled WRITE setEnabled NOTIFY changed)
+    Q_PROPERTY(QIcon icon READ icon WRITE setIcon NOTIFY changed)
+    Q_PROPERTY(QString text READ text WRITE setText NOTIFY changed)
+    Q_PROPERTY(QString iconText READ iconText WRITE setIconText NOTIFY changed)
+    Q_PROPERTY(QString toolTip READ toolTip WRITE setToolTip NOTIFY changed)
+    Q_PROPERTY(QString statusTip READ statusTip WRITE setStatusTip NOTIFY changed)
+    Q_PROPERTY(QString whatsThis READ whatsThis WRITE setWhatsThis NOTIFY changed)
+    Q_PROPERTY(QFont font READ font WRITE setFont NOTIFY changed)
+#if QT_CONFIG(shortcut)
+    Q_PROPERTY(QKeySequence shortcut READ shortcut WRITE setShortcut NOTIFY changed)
+    Q_PROPERTY(Qt::ShortcutContext shortcutContext READ shortcutContext WRITE setShortcutContext NOTIFY changed)
+    Q_PROPERTY(bool autoRepeat READ autoRepeat WRITE setAutoRepeat NOTIFY changed)
+#endif
+    Q_PROPERTY(bool visible READ isVisible WRITE setVisible NOTIFY changed)
+    Q_PROPERTY(MenuRole menuRole READ menuRole WRITE setMenuRole NOTIFY changed)
+    Q_PROPERTY(bool iconVisibleInMenu READ isIconVisibleInMenu WRITE setIconVisibleInMenu NOTIFY changed)
+    Q_PROPERTY(bool shortcutVisibleInContextMenu READ isShortcutVisibleInContextMenu WRITE setShortcutVisibleInContextMenu NOTIFY changed)
+    Q_PROPERTY(Priority priority READ priority WRITE setPriority)
+
+public:
+    // note this is copied into qplatformmenu.h, which must stay in sync
+    enum MenuRole { NoRole = 0, TextHeuristicRole, ApplicationSpecificRole, AboutQtRole,
+                    AboutRole, PreferencesRole, QuitRole };
+    Q_ENUM(MenuRole)
+    enum Priority { LowPriority = 0,
+                    NormalPriority = 128,
+                    HighPriority = 256};
+    Q_ENUM(Priority)
+    explicit QGuiAction(QObject *parent = nullptr);
+    explicit QGuiAction(const QString &text, QObject *parent = nullptr);
+    explicit QGuiAction(const QIcon &icon, const QString &text, QObject *parent = nullptr);
+
+    ~QGuiAction();
+
+    void setActionGroup(QGuiActionGroup *group);
+    QGuiActionGroup *guiActionGroup() const;
+    void setIcon(const QIcon &icon);
+    QIcon icon() const;
+
+    void setText(const QString &text);
+    QString text() const;
+
+    void setIconText(const QString &text);
+    QString iconText() const;
+
+    void setToolTip(const QString &tip);
+    QString toolTip() const;
+
+    void setStatusTip(const QString &statusTip);
+    QString statusTip() const;
+
+    void setWhatsThis(const QString &what);
+    QString whatsThis() const;
+
+    void setPriority(Priority priority);
+    Priority priority() const;
+
+    void setSeparator(bool b);
+    bool isSeparator() const;
+
+#if QT_CONFIG(shortcut)
+    void setShortcut(const QKeySequence &shortcut);
+    QKeySequence shortcut() const;
+
+    void setShortcuts(const QList<QKeySequence> &shortcuts);
+    void setShortcuts(QKeySequence::StandardKey);
+    QList<QKeySequence> shortcuts() const;
+
+    void setShortcutContext(Qt::ShortcutContext context);
+    Qt::ShortcutContext shortcutContext() const;
+
+    void setAutoRepeat(bool);
+    bool autoRepeat() const;
+#endif
+
+    void setFont(const QFont &font);
+    QFont font() const;
+
+    void setCheckable(bool);
+    bool isCheckable() const;
+
+    QVariant data() const;
+    void setData(const QVariant &var);
+
+    bool isChecked() const;
+
+    bool isEnabled() const;
+
+    bool isVisible() const;
+
+    enum ActionEvent { Trigger, Hover };
+    void activate(ActionEvent event);
+
+    void setMenuRole(MenuRole menuRole);
+    MenuRole menuRole() const;
+
+    void setIconVisibleInMenu(bool visible);
+    bool isIconVisibleInMenu() const;
+
+    void setShortcutVisibleInContextMenu(bool show);
+    bool isShortcutVisibleInContextMenu() const;
+
+protected:
+    bool event(QEvent *) override;
+    QGuiAction(QGuiActionPrivate &dd, QObject *parent);
+
+public Q_SLOTS:
+    void trigger() { activate(Trigger); }
+    void hover() { activate(Hover); }
+    void setChecked(bool);
+    void toggle();
+    void setEnabled(bool);
+    inline void setDisabled(bool b) { setEnabled(!b); }
+    void setVisible(bool);
+
+Q_SIGNALS:
+    void changed();
+    void triggered(bool checked = false);
+    void hovered();
+    void toggled(bool);
+
+private:
+    Q_DISABLE_COPY(QGuiAction)
+    friend class QGuiActionGroup;
+};
+
+#ifndef QT_NO_DEBUG_STREAM
+Q_GUI_EXPORT QDebug operator<<(QDebug, const QGuiAction *);
+#endif
+
+#endif // QT_NO_ACTION
+
+QT_END_NAMESPACE
+
+#endif // QGUIACTION_H
diff --git a/src/gui/kernel/qguiaction_p.h b/src/gui/kernel/qguiaction_p.h
new file mode 100644
index 0000000000..850656a4af
--- /dev/null
+++ b/src/gui/kernel/qguiaction_p.h
@@ -0,0 +1,127 @@
+/****************************************************************************
+**
+** Copyright (C) 2016 The Qt Company Ltd.
+** Contact: https://www.qt.io/licensing/
+**
+** This file is part of the QtWidgets module of the Qt Toolkit.
+**
+** $QT_BEGIN_LICENSE:LGPL$
+** Commercial License Usage
+** Licensees holding valid commercial Qt licenses may use this file in
+** accordance with the commercial license agreement provided with the
+** Software or, alternatively, in accordance with the terms contained in
+** a written agreement between you and The Qt Company. For licensing terms
+** and conditions see https://www.qt.io/terms-conditions. For further
+** information use the contact form at https://www.qt.io/contact-us.
+**
+** GNU Lesser General Public License Usage
+** Alternatively, this file may be used under the terms of the GNU Lesser
+** General Public License version 3 as published by the Free Software
+** Foundation and appearing in the file LICENSE.LGPL3 included in the
+** packaging of this file. Please review the following information to
+** ensure the GNU Lesser General Public License version 3 requirements
+** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
+**
+** GNU General Public License Usage
+** Alternatively, this file may be used under the terms of the GNU
+** General Public License version 2.0 or (at your option) the GNU General
+** Public license version 3 or any later version approved by the KDE Free
+** Qt Foundation. The licenses are as published by the Free Software
+** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
+** included in the packaging of this file. Please review the following
+** information to ensure the GNU General Public License requirements will
+** be met: https://www.gnu.org/licenses/gpl-2.0.html and
+** https://www.gnu.org/licenses/gpl-3.0.html.
+**
+** $QT_END_LICENSE$
+**
+****************************************************************************/
+
+#ifndef QGUIACTION_P_H
+#define QGUIACTION_P_H
+
+//
+//  W A R N I N G
+//  -------------
+//
+// This file is not part of the Qt API.  It exists for the convenience
+// of other Qt classes.  This header file may change from version to
+// version without notice, or even be removed.
+//
+// We mean it.
+//
+
+#include <QtGui/private/qtguiglobal_p.h>
+#include <QtGui/qguiaction.h>
+#include <QtGui/qfont.h>
+#include <QtGui/private/qshortcutmap_p.h>
+#include "private/qobject_p.h"
+
+QT_BEGIN_NAMESPACE
+
+#ifndef QT_NO_ACTION
+
+
+class QShortcutMap;
+
+class Q_GUI_EXPORT QGuiActionPrivate : public QObjectPrivate
+{
+    Q_DECLARE_PUBLIC(QGuiAction)
+public:
+    QGuiActionPrivate();
+    ~QGuiActionPrivate();
+
+    virtual QShortcutMap::ContextMatcher contextMatcher() const;
+
+    static QGuiActionPrivate *get(QGuiAction *q)
+    {
+        return q->d_func();
+    }
+
+
+    QPointer<QGuiActionGroup> group;
+    QString text;
+    QString iconText;
+    QIcon icon;
+    QString tooltip;
+    QString statustip;
+    QString whatsthis;
+#if QT_CONFIG(shortcut)
+    QKeySequence shortcut;
+    QList<QKeySequence> alternateShortcuts;
+#endif
+    QVariant userData;
+#if QT_CONFIG(shortcut)
+    int shortcutId = 0;
+    QVector<int> alternateShortcutIds;
+    Qt::ShortcutContext shortcutContext = Qt::WindowShortcut;
+    uint autorepeat : 1;
+#endif
+    QFont font;
+    uint enabled : 1, forceDisabled : 1;
+    uint visible : 1, forceInvisible : 1;
+    uint checkable : 1;
+    uint checked : 1;
+    uint separator : 1;
+    uint fontSet : 1;
+
+    int iconVisibleInMenu : 2;  // Only has values -1, 0, and 1
+    int shortcutVisibleInContextMenu : 2; // Only has values -1, 0, and 1
+
+    QGuiAction::MenuRole menuRole = QGuiAction::TextHeuristicRole;
+    QGuiAction::Priority priority = QGuiAction::NormalPriority;
+
+#if QT_CONFIG(shortcut)
+    void redoGrab(QShortcutMap &map);
+    void redoGrabAlternate(QShortcutMap &map);
+    void setShortcutEnabled(bool enable, QShortcutMap &map);
+#endif // QT_NO_SHORTCUT
+
+    void sendDataChanged();
+};
+
+#endif // QT_NO_ACTION
+
+QT_END_NAMESPACE
+
+#endif // QACTION_P_H
diff --git a/src/gui/kernel/qguiactiongroup.cpp b/src/gui/kernel/qguiactiongroup.cpp
new file mode 100644
index 0000000000..3bfcb63238
--- /dev/null
+++ b/src/gui/kernel/qguiactiongroup.cpp
@@ -0,0 +1,349 @@
+/****************************************************************************
+**
+** Copyright (C) 2016 The Qt Company Ltd.
+** Contact: https://www.qt.io/licensing/
+**
+** This file is part of the QtWidgets module of the Qt Toolkit.
+**
+** $QT_BEGIN_LICENSE:LGPL$
+** Commercial License Usage
+** Licensees holding valid commercial Qt licenses may use this file in
+** accordance with the commercial license agreement provided with the
+** Software or, alternatively, in accordance with the terms contained in
+** a written agreement between you and The Qt Company. For licensing terms
+** and conditions see https://www.qt.io/terms-conditions. For further
+** information use the contact form at https://www.qt.io/contact-us.
+**
+** GNU Lesser General Public License Usage
+** Alternatively, this file may be used under the terms of the GNU Lesser
+** General Public License version 3 as published by the Free Software
+** Foundation and appearing in the file LICENSE.LGPL3 included in the
+** packaging of this file. Please review the following information to
+** ensure the GNU Lesser General Public License version 3 requirements
+** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
+**
+** GNU General Public License Usage
+** Alternatively, this file may be used under the terms of the GNU
+** General Public License version 2.0 or (at your option) the GNU General
+** Public license version 3 or any later version approved by the KDE Free
+** Qt Foundation. The licenses are as published by the Free Software
+** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
+** included in the packaging of this file. Please review the following
+** information to ensure the GNU General Public License requirements will
+** be met: https://www.gnu.org/licenses/gpl-2.0.html and
+** https://www.gnu.org/licenses/gpl-3.0.html.
+**
+** $QT_END_LICENSE$
+**
+****************************************************************************/
+
+#include "qguiactiongroup.h"
+
+#ifndef QT_NO_ACTION
+#include "qguiaction.h"
+#include "qguiaction_p.h"
+#include "qguiactiongroup_p.h"
+#include "qevent.h"
+#include "qlist.h"
+
+QT_BEGIN_NAMESPACE
+
+QGuiActionGroupPrivate::QGuiActionGroupPrivate() :
+    enabled(1), visible(1)
+{
+}
+
+QGuiActionGroupPrivate::~QGuiActionGroupPrivate() = default;
+
+void QGuiActionGroup::_q_actionChanged()
+{
+    Q_D(QGuiActionGroup);
+    auto action = qobject_cast<QGuiAction*>(sender());
+    Q_ASSERT_X(action != nullptr, "QGuiActionGroup::_q_actionChanged", "internal error");
+    if (d->exclusionPolicy != QGuiActionGroup::ExclusionPolicy::None) {
+        if (action->isChecked()) {
+            if (action != d->current) {
+                if (!d->current.isNull())
+                    d->current->setChecked(false);
+                d->current = action;
+            }
+        } else if (action == d->current) {
+            d->current = nullptr;
+        }
+    }
+}
+
+void QGuiActionGroup::_q_actionTriggered()
+{
+    Q_D(QGuiActionGroup);
+    auto action = qobject_cast<QGuiAction*>(sender());
+    Q_ASSERT_X(action != nullptr, "QGuiActionGroup::_q_actionTriggered", "internal error");
+    d->emitSignal(QGuiActionGroupPrivate::Triggered, action);
+}
+
+void QGuiActionGroup::_q_actionHovered()
+{
+    Q_D(QGuiActionGroup);
+    auto action = qobject_cast<QGuiAction*>(sender());
+    Q_ASSERT_X(action != nullptr, "QGuiActionGroup::_q_actionHovered", "internal error");
+    d->emitSignal(QGuiActionGroupPrivate::Hovered, action);
+}
+
+/*!
+    \class QGuiActionGroup
+    \brief The QGuiActionGroup class groups actions together.
+    \since 6.0
+
+    \ingroup TBD
+    \inmodule QtGui
+
+    QGuiActionGroup is a base class for classes grouping
+    classes inhheriting QGuiAction objects together.
+
+    In some situations it is useful to group QGuiAction objects together.
+    For example, if you have a \uicontrol{Left Align} action, a \uicontrol{Right
+    Align} action, a \uicontrol{Justify} action, and a \uicontrol{Center} action,
+    only one of these actions should be active at any one time. One
+    simple way of achieving this is to group the actions together in
+    an action group, inheriting QGuiActionGroup.
+
+    \sa QGuiAction
+*/
+
+/*!
+    \enum QGuiActionGroup::ExclusionPolicy
+
+    This enum specifies the different policies that can be used to
+    control how the group performs exclusive checking on checkable actions.
+
+    \value None
+           The actions in the group can be checked independently of each other.
+
+    \value Exclusive
+           Exactly one action can be checked at any one time.
+           This is the default policy.
+
+    \value ExclusiveOptional
+           At most one action can be checked at any one time. The actions
+           can also be all unchecked.
+
+    \sa exclusionPolicy
+*/
+
+/*!
+    Constructs an action group for the \a parent object.
+
+    The action group is exclusive by default. Call setExclusive(false)
+    to make the action group non-exclusive. To make the group exclusive
+    but allow unchecking the active action call instead
+    setExclusionPolicy(QGuiActionGroup::ExclusionPolicy::ExclusiveOptional)
+*/
+QGuiActionGroup::QGuiActionGroup(QObject* parent) :
+    QGuiActionGroup(*new QGuiActionGroupPrivate, parent)
+{
+}
+
+QGuiActionGroup::QGuiActionGroup(QGuiActionGroupPrivate &dd, QObject *parent) :
+    QObject(dd, parent)
+{
+}
+
+/*!
+    Destroys the action group.
+*/
+QGuiActionGroup::~QGuiActionGroup() = default;
+
+/*!
+    \fn QGuiAction *QGuiActionGroup::addAction(QGuiAction *action)
+
+    Adds the \a action to this group, and returns it.
+
+    Normally an action is added to a group by creating it with the
+    group as its parent, so this function is not usually used.
+
+    \sa QGuiAction::setActionGroup()
+*/
+QGuiAction *QGuiActionGroup::addAction(QGuiAction* a)
+{
+    Q_D(QGuiActionGroup);
+    if (!d->actions.contains(a)) {
+        d->actions.append(a);
+        QObject::connect(a, &QGuiAction::triggered, this, &QGuiActionGroup::_q_actionTriggered);
+        QObject::connect(a, &QGuiAction::changed, this, &QGuiActionGroup::_q_actionChanged);
+        QObject::connect(a, &QGuiAction::hovered, this, &QGuiActionGroup::_q_actionHovered);
+    }
+    if (!a->d_func()->forceDisabled) {
+        a->setEnabled(d->enabled);
+        a->d_func()->forceDisabled = false;
+    }
+    if (!a->d_func()->forceInvisible) {
+        a->setVisible(d->visible);
+        a->d_func()->forceInvisible = false;
+    }
+    if (a->isChecked())
+        d->current = a;
+    QGuiActionGroup *oldGroup = a->d_func()->group;
+    if (oldGroup != this) {
+        if (oldGroup)
+            oldGroup->removeAction(a);
+        a->d_func()->group = this;
+        a->d_func()->sendDataChanged();
+    }
+    return a;
+}
+
+/*!
+  Removes the \a action from this group. The action will have no
+  parent as a result.
+
+  \sa QGuiAction::setActionGroup()
+*/
+void QGuiActionGroup::removeAction(QGuiAction *action)
+{
+    Q_D(QGuiActionGroup);
+    if (d->actions.removeAll(action)) {
+        if (action == d->current)
+            d->current = nullptr;
+        QObject::disconnect(action, &QGuiAction::triggered, this, &QGuiActionGroup::_q_actionTriggered);
+        QObject::disconnect(action, &QGuiAction::changed, this, &QGuiActionGroup::_q_actionChanged);
+        QObject::disconnect(action, &QGuiAction::hovered, this, &QGuiActionGroup::_q_actionHovered);
+        action->d_func()->group = nullptr;
+    }
+}
+
+/*!
+    Returns the list of this groups's actions. This may be empty.
+*/
+QList<QGuiAction*> QGuiActionGroup::guiActions() const
+{
+    Q_D(const QGuiActionGroup);
+    return d->actions;
+}
+
+/*!
+    \brief Enable or disable the group exclusion checking
+
+    This is a convenience method that calls
+    setExclusionPolicy(ExclusionPolicy::Exclusive).
+
+    \sa QGuiActionGroup::exclusionPolicy
+*/
+void QGuiActionGroup::setExclusive(bool b)
+{
+    setExclusionPolicy(b ? QGuiActionGroup::ExclusionPolicy::Exclusive
+                         : QGuiActionGroup::ExclusionPolicy::None);
+}
+
+/*!
+    \brief Returs true if the group is exclusive
+
+    The group is exclusive if the ExclusionPolicy is either Exclusive
+    or ExclusionOptional.
+
+*/
+bool QGuiActionGroup::isExclusive() const
+{
+    return exclusionPolicy() != QGuiActionGroup::ExclusionPolicy::None;
+}
+
+/*!
+    \property QGuiActionGroup::exclusionPolicy
+    \brief This property holds the group exclusive checking policy
+
+    If exclusionPolicy is set to Exclusive, only one checkable
+    action in the action group can ever be active at any time. If the user
+    chooses another checkable action in the group, the one they chose becomes
+    active and the one that was active becomes inactive. If exclusionPolicy is
+    set to ExclusionOptional the group is exclusive but the active checkable
+    action in the group can be unchecked leaving the group with no actions
+    checked.
+
+    \sa QGuiAction::checkable
+*/
+void QGuiActionGroup::setExclusionPolicy(QGuiActionGroup::ExclusionPolicy policy)
+{
+    Q_D(QGuiActionGroup);
+    d->exclusionPolicy = policy;
+}
+
+QGuiActionGroup::ExclusionPolicy QGuiActionGroup::exclusionPolicy() const
+{
+    Q_D(const QGuiActionGroup);
+    return d->exclusionPolicy;
+}
+
+/*!
+    \fn void QGuiActionGroup::setDisabled(bool b)
+
+    This is a convenience function for the \l enabled property, that
+    is useful for signals--slots connections. If \a b is true the
+    action group is disabled; otherwise it is enabled.
+*/
+
+/*!
+    \property QGuiActionGroup::enabled
+    \brief whether the action group is enabled
+
+    Each action in the group will be enabled or disabled unless it
+    has been explicitly disabled.
+
+    \sa QGuiAction::setEnabled()
+*/
+void QGuiActionGroup::setEnabled(bool b)
+{
+    Q_D(QGuiActionGroup);
+    d->enabled = b;
+    for (auto action : qAsConst(d->actions)) {
+        if (!action->d_func()->forceDisabled) {
+            action->setEnabled(b);
+            action->d_func()->forceDisabled = false;
+        }
+    }
+}
+
+bool QGuiActionGroup::isEnabled() const
+{
+    Q_D(const QGuiActionGroup);
+    return d->enabled;
+}
+
+/*!
+  Returns the currently checked action in the group, or \nullptr if
+  none are checked.
+*/
+QGuiAction *QGuiActionGroup::checkedGuiAction() const
+{
+    Q_D(const QGuiActionGroup);
+    return d->current.data();
+}
+
+/*!
+    \property QGuiActionGroup::visible
+    \brief whether the action group is visible
+
+    Each action in the action group will match the visible state of
+    this group unless it has been explicitly hidden.
+
+    \sa QGuiAction::setEnabled()
+*/
+void QGuiActionGroup::setVisible(bool b)
+{
+    Q_D(QGuiActionGroup);
+    d->visible = b;
+    for (auto action : qAsConst(d->actions)) {
+        if (!action->d_func()->forceInvisible) {
+            action->setVisible(b);
+            action->d_func()->forceInvisible = false;
+        }
+    }
+}
+
+bool QGuiActionGroup::isVisible() const
+{
+    Q_D(const QGuiActionGroup);
+    return d->visible;
+}
+
+QT_END_NAMESPACE
+
+#endif // QT_NO_ACTION
diff --git a/src/gui/kernel/qguiactiongroup.h b/src/gui/kernel/qguiactiongroup.h
new file mode 100644
index 0000000000..ae25c2e768
--- /dev/null
+++ b/src/gui/kernel/qguiactiongroup.h
@@ -0,0 +1,107 @@
+/****************************************************************************
+**
+** Copyright (C) 2016 The Qt Company Ltd.
+** Contact: https://www.qt.io/licensing/
+**
+** This file is part of the QtWidgets module of the Qt Toolkit.
+**
+** $QT_BEGIN_LICENSE:LGPL$
+** Commercial License Usage
+** Licensees holding valid commercial Qt licenses may use this file in
+** accordance with the commercial license agreement provided with the
+** Software or, alternatively, in accordance with the terms contained in
+** a written agreement between you and The Qt Company. For licensing terms
+** and conditions see https://www.qt.io/terms-conditions. For further
+** information use the contact form at https://www.qt.io/contact-us.
+**
+** GNU Lesser General Public License Usage
+** Alternatively, this file may be used under the terms of the GNU Lesser
+** General Public License version 3 as published by the Free Software
+** Foundation and appearing in the file LICENSE.LGPL3 included in the
+** packaging of this file. Please review the following information to
+** ensure the GNU Lesser General Public License version 3 requirements
+** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
+**
+** GNU General Public License Usage
+** Alternatively, this file may be used under the terms of the GNU
+** General Public License version 2.0 or (at your option) the GNU General
+** Public license version 3 or any later version approved by the KDE Free
+** Qt Foundation. The licenses are as published by the Free Software
+** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
+** included in the packaging of this file. Please review the following
+** information to ensure the GNU General Public License requirements will
+** be met: https://www.gnu.org/licenses/gpl-2.0.html and
+** https://www.gnu.org/licenses/gpl-3.0.html.
+**
+** $QT_END_LICENSE$
+**
+****************************************************************************/
+
+#ifndef QGUIACTIONGROUP_H
+#define QGUIACTIONGROUP_H
+
+#include <QtGui/qtguiglobal.h>
+#include <QtGui/qguiaction.h>
+
+QT_BEGIN_NAMESPACE
+
+
+#ifndef QT_NO_ACTION
+
+class QGuiActionGroupPrivate;
+
+class Q_GUI_EXPORT QGuiActionGroup : public QObject
+{
+    Q_OBJECT
+    Q_DECLARE_PRIVATE(QGuiActionGroup)
+
+    Q_PROPERTY(QGuiActionGroup::ExclusionPolicy exclusionPolicy READ exclusionPolicy WRITE setExclusionPolicy)
+    Q_PROPERTY(bool enabled READ isEnabled WRITE setEnabled)
+    Q_PROPERTY(bool visible READ isVisible WRITE setVisible)
+
+public:
+    enum class ExclusionPolicy {
+        None,
+        Exclusive,
+        ExclusiveOptional
+    };
+    Q_ENUM(ExclusionPolicy)
+
+    explicit QGuiActionGroup(QObject *parent);
+    ~QGuiActionGroup();
+
+    QGuiAction *addAction(QGuiAction *a);
+    void removeAction(QGuiAction *a);
+    QList<QGuiAction*> guiActions() const;
+    QGuiAction *checkedGuiAction() const;
+
+    bool isExclusive() const;
+    bool isEnabled() const;
+    bool isVisible() const;
+    ExclusionPolicy exclusionPolicy() const;
+
+
+public Q_SLOTS:
+    void setEnabled(bool);
+    inline void setDisabled(bool b) { setEnabled(!b); }
+    void setVisible(bool);
+    void setExclusive(bool);
+    void setExclusionPolicy(ExclusionPolicy policy);
+
+private Q_SLOTS:
+    void _q_actionTriggered();
+    void _q_actionHovered();
+    void _q_actionChanged();
+
+protected:
+     QGuiActionGroup(QGuiActionGroupPrivate &dd, QObject *parent);
+
+private:
+    Q_DISABLE_COPY(QGuiActionGroup)
+};
+
+#endif // QT_NO_ACTION
+
+QT_END_NAMESPACE
+
+#endif // QGUIACTIONGROUP_H
diff --git a/src/gui/kernel/qguiactiongroup_p.h b/src/gui/kernel/qguiactiongroup_p.h
new file mode 100644
index 0000000000..d2f41f26c4
--- /dev/null
+++ b/src/gui/kernel/qguiactiongroup_p.h
@@ -0,0 +1,91 @@
+/****************************************************************************
+**
+** Copyright (C) 2016 The Qt Company Ltd.
+** Contact: https://www.qt.io/licensing/
+**
+** This file is part of the QtWidgets module of the Qt Toolkit.
+**
+** $QT_BEGIN_LICENSE:LGPL$
+** Commercial License Usage
+** Licensees holding valid commercial Qt licenses may use this file in
+** accordance with the commercial license agreement provided with the
+** Software or, alternatively, in accordance with the terms contained in
+** a written agreement between you and The Qt Company. For licensing terms
+** and conditions see https://www.qt.io/terms-conditions. For further
+** information use the contact form at https://www.qt.io/contact-us.
+**
+** GNU Lesser General Public License Usage
+** Alternatively, this file may be used under the terms of the GNU Lesser
+** General Public License version 3 as published by the Free Software
+** Foundation and appearing in the file LICENSE.LGPL3 included in the
+** packaging of this file. Please review the following information to
+** ensure the GNU Lesser General Public License version 3 requirements
+** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
+**
+** GNU General Public License Usage
+** Alternatively, this file may be used under the terms of the GNU
+** General Public License version 2.0 or (at your option) the GNU General
+** Public license version 3 or any later version approved by the KDE Free
+** Qt Foundation. The licenses are as published by the Free Software
+** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
+** included in the packaging of this file. Please review the following
+** information to ensure the GNU General Public License requirements will
+** be met: https://www.gnu.org/licenses/gpl-2.0.html and
+** https://www.gnu.org/licenses/gpl-3.0.html.
+**
+** $QT_END_LICENSE$
+**
+****************************************************************************/
+
+#ifndef QGUIACTIONGROUP_P_H
+#define QGUIACTIONGROUP_P_H
+
+//
+//  W A R N I N G
+//  -------------
+//
+// This file is not part of the Qt API. It exists for the convenience
+// of other Qt classes. This header file may change from version to
+// version without notice, or even be removed.
+//
+// We mean it.
+//
+
+#include <QtGui/private/qtguiglobal_p.h>
+#include <QtGui/qguiactiongroup.h>
+#include <QtGui/qfont.h>
+#include <QtGui/private/qshortcutmap_p.h>
+#include "private/qobject_p.h"
+
+QT_BEGIN_NAMESPACE
+
+#ifndef QT_NO_ACTION
+
+class Q_GUI_EXPORT QGuiActionGroupPrivate : public QObjectPrivate
+{
+    Q_DECLARE_PUBLIC(QGuiActionGroup)
+public:
+    enum Signal { Triggered, Hovered };
+
+    QGuiActionGroupPrivate();
+    ~QGuiActionGroupPrivate();
+
+    virtual void emitSignal(Signal, QGuiAction *) {}
+
+    QList<QGuiAction *> actions;
+    QPointer<QGuiAction> current;
+    uint enabled : 1;
+    uint visible : 1;
+    QGuiActionGroup::ExclusionPolicy exclusionPolicy = QGuiActionGroup::ExclusionPolicy::Exclusive;
+
+private:
+    void _q_actionTriggered();  //private slot
+    void _q_actionChanged();    //private slot
+    void _q_actionHovered();    //private slot
+};
+
+#endif // QT_NO_ACTION
+
+QT_END_NAMESPACE
+
+#endif // QACTIONGROUP_P_H
diff --git a/src/widgets/graphicsview/qgraphicswidget.h b/src/widgets/graphicsview/qgraphicswidget.h
index 8223b921c9..b757af5c0e 100644
--- a/src/widgets/graphicsview/qgraphicswidget.h
+++ b/src/widgets/graphicsview/qgraphicswidget.h
@@ -42,6 +42,7 @@
 
 #include <QtWidgets/qtwidgetsglobal.h>
 #include <QtGui/qfont.h>
+#include <QtWidgets/qaction.h>
 #include <QtWidgets/qgraphicslayoutitem.h>
 #include <QtWidgets/qgraphicsitem.h>
 #include <QtGui/qpalette.h>
